--bu bilgiler için excel ile göndediğim tabloyu kullanabilirsiniz. aşağıdaki tablolara yetkiniz bulunmuyor. excel iele manuel yüklenmeli
--CREATE TABLE  cc_sicil AS
--SELECT distinct CK.KLNC_SICILNO sicilno 
--  FROM tc.CROL R, tc.CROL_KLNC CK WHERE R.TUR = 'F'
--   AND R.CROLKOD = CK.CROLKOD

--maaş ilişkisi olan müşterileri ve ilişki tarihlerini buluyoruz. birden fazla maaş tanımı olabileceği için ilk kayıt alınacak sekilde partition yapılır
CREATE TABLE goker.maas_iliski 
distribute by hash(cmusno)
compress
AS    
SELECT cmusno, tar
  FROM (SELECT CMUSNO, tar::date as tar,
               ROW_NUMBER() OVER (PARTITION BY CMUSNO ORDER BY TAR ASC) SIRA
          FROM staging.pov_dwd_cmus_iliski
         WHERE ILISKITURNO = 3 
           AND drm='G') drv
 WHERE sira = 1

-- select count(*)
-- from goker.maas_iliski 

--count(1)
--1755818

--yukarıdaki iliski ve sicil bilgilerini de kullanarak edinim kanalları maplenir 
DROP TABLE onboarding.edinim_kanal;
CREATE TABLE onboarding.edinim_kanal 
distribute by hash(cmusno)
compress
AS
SELECT k.cmusno,
	   case when g.drm_tar is not null then g.drm_tar::timestamp
	   		else k.d_ilk_edinim_tar end as d_ilk_edinim_tar,
       CASE WHEN g.drm_tar is not null then 'CEPTETEB' 
       		WHEN (M.REF_MUS_EDN_SKL IN ('12','27') or C.SICILNO =  999934) AND H.SICILNO IS NULL AND (L.TAR::date) between (c.tar::date) and ((c.tar::date)+30)::date THEN 'DIREK_SATIS_MAAS'
       		WHEN M.REF_MUS_EDN_SKL IN ('55') AND C.SICILNO =  999934 then 'DIREK_SATIS_EMEKLI'
	        WHEN C.SICILNO =  999934 THEN 'DIREK_SATIS'     
	        WHEN C.SICILNO <> 999951 AND M.REF_MUS_EDN_SKL IN ('12','27') THEN 'DIREK_SATIS'
	        WHEN coalesce(REF_MUS_EDN_SKL,'99999') <> '8' AND H.SICILNO IS NULL AND (L.TAR::date) between (c.tar::date) and ((c.tar::date)+30)::date THEN 'MAAS'
	        when M.REF_MUS_EDN_SKL IN ('23','24','25','26','30','29','31','32','58','47','50','56') then 'TOPLU_EDINIM'
            WHEN M.REF_MUS_EDN_SKL IN ('41') THEN 'PUSULA_MOBIL'
            WHEN H.SICILNO IS NOT NULL AND M.REF_MUS_EDN_SKL NOT IN ('34','37','35','39','38','36','40') THEN 'CALL_CENTER'
            WHEN H.SICILNO IS NOT NULL AND M.REF_MUS_EDN_SKL NOT IN ('48','49') THEN 'CALL_CENTER_DIGER'
            WHEN C.SICILNO = 999951 THEN 'ISTIRAK'
            WHEN M.REF_MUS_EDN_SKL in  ('8','52') then 'INTERNET'
            WHEN M.REF_MUS_EDN_SKL in  ('20','16','43','45') THEN 'SMS'
            WHEN C.SICILNO <> 999951 AND M.REF_MUS_EDN_SKL IN ('22') THEN 'PTT'
            WHEN M.REF_MUS_EDN_SKL= '21'THEN 'WEB'
            WHEN M.REF_MUS_EDN_SKL IN ('34','37','35','39','38','36','40','28') and (c.kanalno in (5041,5930, 5046) or c.sicilno =999944) THEN 'CEPTETEB_MOBIL'
            WHEN (c.kanalno in (5041,5930, 5046) or c.sicilno =999944) THEN 'CEPTETEB_MOBIL'
            WHEN M.REF_MUS_EDN_SKL IN ('34','37','35','39','38','36','40','28') and (c.kanalno in (5929,5070) or c.sicilno in (999993,999957)) THEN 'CEPTETEB_WEB'
            WHEN (c.kanalno in (5929,5070) or c.sicilno in (999993,999957)) THEN 'CEPTETEB_WEB'
            WHEN M.REF_MUS_EDN_SKL IN ('34','37','35','39','38','36','40','28') THEN 'CEPTETEB' 
            when (M.REF_MUS_EDN_SKL IN ('61','62') or  C.sicilno = 999955) then 'SNK'
            when M.REF_MUS_EDN_SKL = '60' then 'HESAP_KURDU'
            when M.REF_MUS_EDN_SKL = '44' then 'IDO'
            when M.REF_MUS_EDN_SKL = '53' or c.sicilno = 999959 then 'TURBOJET'
            when M.REF_MUS_EDN_SKL = '54' then 'YSK'
            when  M.REF_MUS_EDN_SKL  in ('3','4','5','6','11') then 'DIGER_DEVIR'
         ELSE 'SUBE' END  edinim_kanal ,
         c.sicilno,
         c.kanalno
  FROM staging.pov_DWD_KON_MUSTERI K
  inner join dw_out.CMUSTERI_TUM C
  	on K.CMUSNO = C.CMUSNO
  	and K.TARIH_ID = '05-31-2018' 
  left join dw_out.DWD_KON_MUSTERI_EK M
  	on  K.CMUSNO = M.CMUSNO
  left join goker.cc_siciller H
  	on C.SICILNO = H.SICILNO
  left join goker.maas_iliski L
  	on K.CMUSNO  = L.CMUSNO
  left join onboarding.cepteteb_edinim G
  	on K.CMUSNO  = G.CMUSNO  	;
  	
analyze onboarding.edinim_kanal ;
grant all on onboarding.edinim_kanal to db_analytics;

select edinim_kanal, count(*)
from onboarding.edinim_kanal a
join staging.pov_dwd_kon_musteri b
on  a.cmusno=b.cmusno
and b.tarih_id::date='04-30-2018'
and a.d_ilk_edinim_tar between '04-01-2018' and '04-30-2018' 
where d_ref_mus_drm='1'
group by 1;



drop table onboarding.cepteteb_edinim 
select *
from onboarding.edinim_kanal 
limit 100;

select *
from onboarding.cepteteb_edinim
limit 100;

select d_ilk_edinim_tar::date, a.cmusno,edinim_kanal
from goker.edinim_kanal a
join goker."nisan edinim cepteteb" b
on a.cmusno=b.cmusno

group by 1,2;



select edinim_kanal, count(*)
from onboarding.edinim_kanal a
join staging.pov_dwd_kon_musteri b
on  a.cmusno=b.cmusno
and b.tarih_id::date='04-30-2018'
and a.d_ilk_edinim_tar between '04-01-2018' and '04-30-2018' or 
where d_ref_mus_drm='1'
group by 1;


select *
from goker.edinim_kanal 
where cmusno=13910888 ;

Kurye	12172789
Kurye	12310730
Kurye	12329887
Kurye	13131789
Kurye	13910888
Onboarder	10747695
Onboarder	11209328
Onboarder	11871412
Onboarder	12585595
Onboarder	13765150

22392709
22153208 

22911745
22912166

select *
from goker.maas_iliski 
where cmusno=22912166 ;

okul kmh
4351739 şube 
23593709
maas
23401907
23371774

21067181 callcenter
3097983 iştirak

select REF_MUS_EDN_SKL,*
from dw_out.DWD_KON_MUSTERI_EK
where cmusno=23082698
;

select sicilno,kanalno,*
from dw_out.CMUSTERI_TUM
where cmusno=22911745;

select d_ilk_edinim_tar,d_ref_mus_drm,*
from staging.pov_DWD_KON_MUSTERI
where cmusno=12585595;

select *
from "staging"."pov_referans"
where tblad like '%MUS_EDN_SKL%'

  	
-- WHERE K.TARIH_ID = '12-31-2016' 
--   AND K.D_REF_MUS_DRM = 1 
--   AND K.CMUSNO = C.CMUSNO
--   AND K.CMUSNO = M.CMUSNO (+)
--   AND C.SICILNO = H.SICILNO (+)
--   AND K.CMUSNO  = L.CMUSNO (+)  

drop table goker.cepteteb_kapalidan_edinim;
create table goker.cepteteb_kapalidan_edinim
distribute by hash(cmusno)
compress
AS
select a.cmusno,a.d_son_edinim_tar,(date_trunc('month', a.d_son_edinim_tar) - interval '24:00:00'), a.d_son_edinim_sube, a.d_ref_mus_drm as new_cust_status, b.d_ref_mus_drm as old_cust_status, a.tarih_id
from staging.pov_dwd_kon_musteri a 
join staging.pov_dwd_kon_musteri b
on a.cmusno=b.cmusno 
	and (date_trunc('month', a.d_son_edinim_tar) - interval '24:00:00')=b.tarih_id
	and b.d_ref_mus_drm != '1'
	and a.d_son_edinim_sube='929';
	
select old_cust_status,new_cust_status, count(*), count(distinct cmusno) 
from goker.cepteteb_kapalidan_edinim
where d_son_edinim_tar between '04-01-2018' and '04-30-2018'
group by 1,2;

select distinct a.cmusno, d_son_edinim_sube::varchar
from goker.cepteteb_kapalidan_edinim a
join goker."nisan edinim cepteteb" b
on a.cmusno=b.cmusno
	 and d_son_edinim_tar between '04-01-2018' and '04-30-2018'
union
select c.cmusno, edinim_kanal
from goker.edinim_kanal c
join goker."nisan edinim cepteteb" d
on d.cmusno=c.cmusno
 and d_ilk_edinim_tar between '04-01-2018' and '04-30-2018'

select distinct a.*
from goker."nisan edinim cepteteb" a --5074
left join 
(
select cmusno
from goker.edinim_kanal  --nisanda edinilenler 1130
where d_ilk_edinim_tar between '04-01-2018' and '04-30-2018'
union
select cmusno
from goker.cepteteb_kapalidan_edinim b --edinim tarihi nisandan önce olup kapalıdan edinilenler var 2613
where d_son_edinim_tar between '04-01-2018' and '04-30-2018'
) b
on a.cmusno=b.cmusno
where b.cmusno is null


select distinct k.cmusno, d_son_edinim_tar::date, d_son_edinim_sube, d_ilk_edinim_tar::date, d_ref_mus_drm
from staging.pov_dwd_kon_musteri k
join (
select distinct a.*
from goker."nisan edinim cepteteb" a --5074
left join 
(
select cmusno
from goker.edinim_kanal  --nisanda edinilenler 1130
where d_ilk_edinim_tar between '04-01-2018' and '04-30-2018'
union
select cmusno
from goker.cepteteb_kapalidan_edinim b --edinim tarihi nisandan önce olup kapalıdan edinilenler var 2613
where d_son_edinim_tar between '04-01-2018' and '04-30-2018'
) b
on a.cmusno=b.cmusno
where b.cmusno is null
) a
on k.cmusno=a.cmusno
and k.tarih_id<='04-30-2018'
order by cmusno, d_son_edinim_tar::date;


select d_son_edinim_tar::date,d_son_edinim_sube,d_ilk_edinim_tar::date, d_ref_mus_drm, tarih_id,*
from staging.pov_dwd_kon_musteri
where cmusno=375407
order by tarih_id::Date desc


select *
from goker.cepteteb_kapalidan_edinim
where cmusno=375407

select cmusno,d_son_edinim_tar,(date_trunc('month', d_son_edinim_tar) - interval '24:00:00'), d_son_edinim_sube, d_ref_mus_drm , tarih_id
from staging.pov_dwd_kon_musteri 
where cmusno=131065


select count(*) from onboarding.cepteteb_edinim