--==============================================================================
-- Fee Charge/Reversal Events
--Start and End date is being used from staging.pov_control_path control table.
--==============================================================================


--Credit Card Fee Charged, needs verification
INSERT INTO goker.event_list
SELECT k.d_cmusno as CMUSNO
		,19035 as event_id
		,CAST(islemtarih as TIMESTAMP) as EVENT_DATE
		,'FEE' as domain_type
		,'CCFeeChrgd' as EVENT1 
		,'' as EVENT2
		,'' as EVENT3
		,'' as chn_name		
FROM "staging"."pov_dwf_kart_harbilgi" h
JOIN staging.pov_control_path control_tab ON 1=1
INNER JOIN "dw_out"."dwd_kart" k
ON
(h.kartno = k.kartno and k.tarih_id=control_tab.snapshot_date /*'2017-09-30 00:00:00'*/ AND k.D_KREDIDEBIT='C')
where h.islemtarih >=  CAST(control_tab.start_date as DATE)--'2015-10-01 00:00:00'
and h.islemtarih <= CAST(control_tab.end_date as DATE)--'2017-09-30 00:00:00'
and h.otc= 1119 and h.ots = 1144 ;
--STATEMENT 1: Insert Statement completed. 692275 rows processed.


--Credit Card Fee Reversal Full/Partial
INSERT INTO goker.event_list
SELECT d_cmusno as CMUSNO
		,case when fee_reversed.islemtutariyi = fee_charged.islemtutariyi then 19036
	      else 19037
	      END AS event_id
		,CAST(fee_reversed.islemtarih as TIMESTAMP) as EVENT_DATE
		,'FEE'as domain_type
		,'CCFeeRvrsd' as EVENT1
		,CASE	WHEN fee_reversed.islemtutariyi = fee_charged.islemtutariyi 
					THEN 'Full'
				ELSE 'Partial'
		 END as EVENT2
		,'' as EVENT3
		,'' as CHANNEL		 
FROM
(
	SELECT
	kartno
	,islemtutariyi
	,tarih_id
	FROM
	"staging"."pov_dwf_kart_harbilgi" h
	JOIN staging.pov_control_path control_tab ON 1=1
	where h.islemtarih >=  CAST(control_tab.start_date as DATE)
	and h.islemtarih <= CAST(control_tab.end_date as DATE)
	and h.otc= 1119 and h.ots = 1144
) fee_charged
JOIN staging.pov_control_path control_tab ON 1=1
INNER JOIN
"dw_out"."dwd_kart" card_detail
ON (fee_charged.kartno = card_detail.kartno and card_detail.tarih_id=control_tab.snapshot_date/*'2017-07-31 00:00:00.000000'*/ AND card_detail.D_KREDIDEBIT='C')
INNER JOIN
(
	SELECT
	kartno
	,islemtutariyi
	,tarih_id
	,islemtarih
	FROM
	"staging"."pov_dwf_kart_harbilgi" h
	JOIN staging.pov_control_path control_tab ON 1=1
	where h.islemtarih >=  CAST(control_tab.start_date as DATE)--'2015-10-01 00:00:00'
	and h.islemtarih <= CAST(control_tab.end_date as DATE)--'2017-09-30 00:00:00'
	and h.otc= 1111 and h.ots = 1144
) fee_reversed
ON fee_charged.kartno = fee_reversed.kartno;
--STATEMENT 2: Insert Statement completed. 24011 rows processed

/*
select event_id, domain_type, EVENT1, EVENT2, EVENT3, count(cmusno)
from zeren.event_list
where domain_type='CREDIT_CARD' 
group by event_id, domain_type, EVENT1, EVENT2, EVENT3;

select  domain_type, EVENT1, EVENT2, EVENT3, count(cust_id)
from staging.path_events
where domain_type='CREDIT CARD'
group by  domain_type, EVENT1, EVENT2, EVENT3;
*/

/*

select event_id, domain_type, EVENT1, EVENT2, EVENT3, count(cmusno)
from zeren.event_list
where domain_type='FEE' 
and event_id in (19035,
19036,
19037)
group by event_id, domain_type, EVENT1, EVENT2, EVENT3;
 */

--DELETE FROM zeren.event_list WHERE DOMAIN_TYPE='CREDIT_CARD';



