--==============================================================================
--Address and Permission Change Events
--Start and End date is being used from onboarding.control_path control table.
--==============================================================================


--Address Change - to be updated later
INSERT INTO onboarding.event_list
SELECT cmusno  
		, 15001 as event_id
		, upd_date as EVENT_DATE
		,'CUST_INFO'
		,'AddressCh' as EVENT1
		,'' as EVENT2
		,'' as EVENT3
		,'' 
FROM
onboarding.customer_status_change
JOIN
onboarding.control_path control_tab
ON 1=1
WHERE UPD_CODE='201' AND UPD_DATE BETWEEN control_tab.start_date AND control_tab.end_date and null_adress_flag!='Y';
--STATEMENT 1: Insert Statement completed. 3381751  rows processed. 

--Branch Change - to be updated later
INSERT INTO onboarding.event_list
SELECT cmusno
		, 15002 as event_id
		, upd_date as EVENT_DATE
		,'CUST_INFO'
		,'BranchCh' as EVENT1
		,'' as EVENT2
		,'' as EVENT3
		,'' 
FROM
onboarding.customer_status_change
JOIN
onboarding.control_path control_tab
ON 1=1
WHERE UPD_CODE='358' AND UPD_DATE BETWEEN control_tab.start_date AND control_tab.end_date and null_adress_flag!='Y';
--STATEMENT 1: Insert Statement completed. 2320438  rows processed. 



--Call / Email / SMS Permisson Flag
INSERT INTO onboarding.event_list
select drv.cmusno
, case when drv.event1='MarPermGranted' AND drv.event2='Call' then 15003
		when drv.event1='MarPermRevoked' AND drv.event2='Call' then 15004
		when drv.event1='MarOtherPermCh' AND drv.event2='Call' then 15005
		when drv.event1='MarPermGranted' AND drv.event2='Email' then 15006
		when drv.event1='MarPermRevoked' AND drv.event2='Email' then 15007
		when drv.event1='MarOtherPermCh' AND drv.event2='Email' then 15008
		when drv.event1='MarPermGranted' AND drv.event2='SMS' then 15009
		when drv.event1='MarPermRevoked' AND drv.event2='SMS' then 15010
		when drv.event1='MarOtherPermCh' AND drv.event2='SMS' then 15011
end as event_id
,drv.event_date
,drv.domain_type
,drv.event1
,drv.event2
,drv.EVENT3
,drv.chn_name
from
(SELECT cmusno as cmusno
		,upd_date as EVENT_DATE
		,'CUST_INFO' as domain_type
		,CASE WHEN new_value='E' THEN 'MarPermGranted'
			  WHEN new_value='H' THEN 'MarPermRevoked'
			  ELSE 'MarOtherPermCh'
		end as event1
		, case when UPD_CODE='302' then 'Call'
			 when UPD_CODE='303' then 'Email'
			 when UPD_CODE='304' then 'SMS'
		end as event2
		,'' as EVENT3
		,'' as chn_name		
FROM
onboarding.customer_status_change
JOIN
onboarding.control_path control_tab
ON 1=1
WHERE UPD_CODE in ('302', '303','304') AND UPD_DATE BETWEEN control_tab.start_date AND control_tab.end_date)drv;
--STATEMENT 1: Insert Statement completed. 3578000  rows processed. 

-- DELETE FROM onboarding.event_list WHERE DOMAIN_TYPE='CUST_INFO';


--Portfolio Change

INSERT INTO onboarding.event_list
SELECT cmusno
		, case when PRT3!=PRT4 then 15012
			else 15013
		end as event_id
		, tarih_id as EVENT_DATE
		,'CUST_INFO'
		,'PortfolioCh' as EVENT1
		,CASE	WHEN PRT3!=PRT4 THEN 'Type'
				ELSE 'Person' END as EVENT2
		,'' as EVENT3
		,'' as CHANNEL		
FROM
(
	SELECT
	cmusno
	,tarih_id
	,MAX(portfoy_ad) OVER (PARTITION BY cmusno ORDER BY tarih_id ASC ROWS BETWEEN 1 PRECEDING AND CURRENT ROW) as PRT1
	,MIN(portfoy_ad) OVER (PARTITION BY cmusno ORDER BY tarih_id ASC ROWS BETWEEN 1 PRECEDING AND CURRENT ROW) as PRT2
	,MAX(portfoy_tip_ack) OVER (PARTITION BY cmusno ORDER BY tarih_id ASC ROWS BETWEEN 1 PRECEDING AND CURRENT ROW) as PRT3
	,MIN(portfoy_tip_ack) OVER (PARTITION BY cmusno ORDER BY tarih_id ASC ROWS BETWEEN 1 PRECEDING AND CURRENT ROW) as PRT4
	FROM
	staging.pov_dwd_kon_musteri
	JOIN
	onboarding.control_path control_tab 
	ON 1=1
	WHERE tarih_id BETWEEN control_tab.start_date AND control_tab.end_date
) DRV
WHERE PRT1!=PRT2;
--STATEMENT 1: Insert Statement completed. 6967613  rows processed. 

/*
select event_id, domain_type, EVENT1, EVENT2, EVENT3, count(cmusno)
from onboarding.event_list
where domain_type='CUST_INFO' and event1='PortfolioCh'
group by event_id, domain_type, EVENT1, EVENT2, EVENT3;

select event_id, domain_type, EVENT1, EVENT2, EVENT3, count(cmusno)
from onboarding.event_list
where domain_type='CUST_INFO' and event_id in (15001,15002)
group by event_id, domain_type, EVENT1, EVENT2, EVENT3;


select  domain_type, EVENT1, EVENT2, EVENT3, count(cust_id)
from staging.path_events
where domain_type like '%INFO%'
group by  domain_type, EVENT1, EVENT2, EVENT3;
*/



/* eski versiyon, update edildi - g�ker gizem

INSERT INTO staging.path_events
SELECT cmusno as CMUS_NO
		, tarih_id as EVENT_DATE
		,'INFO UPDATE'
		,'PORTFOLIO CHANGE' as EVENT1
		,'PORTFOLIO CHANGE' as EVENT2
		,'' as EVENT3
		,'' as CHANNEL		
FROM
(
	SELECT
	cmusno
	,tarih_id
	,MAX(portfoy_ad) OVER (PARTITION BY cmusno ORDER BY tarih_id ASC ROWS BETWEEN 1 PRECEDING AND CURRENT ROW) as PRT1
	,MIN(portfoy_ad) OVER (PARTITION BY cmusno ORDER BY tarih_id ASC ROWS BETWEEN 1 PRECEDING AND CURRENT ROW) as PRT2
	FROM
	"staging"."pov_dwd_kon_musteri"
	WHERE d_ref_mus_drm='1' -- Need verification
) DRV
WHERE PRT1!=PRT2;

*/