--DELETE FROM onboarding.event_list WHERE DOMAIN_type='MARKETING_OFFER';

/*Marketing Login Banner Events*/
INSERT INTO onboarding.event_list
SELECT cmusno 
, case when HUBKANALNO=130 and HUBCVPTIPNO=1005 THEN 17001
		when HUBKANALNO=130 and HUBCVPTIPNO=1009 THEN 17002
		when HUBKANALNO=130 and HUBCVPTIPNO=1013 THEN 17003
		when HUBKANALNO=130 and HUBCVPTIPNO in (1014,1022) THEN 17004
		when HUBKANALNO=131 and HUBCVPTIPNO=1005 THEN 17005
		when HUBKANALNO=131 and HUBCVPTIPNO=1009 THEN 17006
		when HUBKANALNO=131 and HUBCVPTIPNO=1013 THEN 17007
		when HUBKANALNO=131 and HUBCVPTIPNO in (1014,1022) THEN 17008
		when HUBKANALNO=129 and HUBCVPTIPNO=1005 THEN 17009
		when HUBKANALNO=129 and HUBCVPTIPNO=1009 THEN 17010
		when HUBKANALNO=129 and HUBCVPTIPNO=1013 THEN 17011
		when HUBKANALNO=129 and HUBCVPTIPNO in (1014,1022) THEN 17012
	end as event_id
		,tar as EVENT_DATE
		,'MARKETING_OFFER' AS DOMAIN_type
		,CASE 
			WHEN HUBKANALNO=130 THEN 'LBClassic'
			WHEN HUBKANALNO=131 THEN 'LBCepteteb'
			WHEN HUBKANALNO=129 THEN 'LBCorporate'--yeni eklendi - goker
		END as EVENT1
		,CASE 
			WHEN HUBCVPTIPNO=1005 THEN 'Presented'
			WHEN HUBCVPTIPNO=1009 THEN 'Postponed'
			WHEN HUBCVPTIPNO=1013 THEN 'Accepted'
			WHEN HUBCVPTIPNO in (1014,1022) THEN 'Rejected'
		END as EVENT2
		,'' as EVENT3
		,'' as CHANNEL		
FROM
(select 
DISTINCT CMT_LEADID,
tar,
CMUSNO,
TEKLIF_KOD,
HUBKANALNO,
HUBCVPTIPNO
from Staging.POV_SNAP$_S_HUB_MUS_CK_TARIHCE 
JOIN
onboarding.control_path control_tab 
ON 1=1
where HUBKANALNO in (129,130,131) 
and tar BETWEEN control_tab.start_date AND control_tab.end_date ) drv
;
 --STATEMENT 1: Insert Statement completed. 16447203  rows processed.
 
--HUBCVPTIPNO AD                    
--
------------- ----------------------
--
--1005        Teklif sunuldu
--
--1009        Tekrar aranmak istiyor
--
--1013        Teklif kabul edildi
--
--1014        Teklifi reddetti
--
--1022        Ilgilenmedi 


--DELETE FROM onboarding.event_list WHERE event_id in (17013,17014,17015,17016,17017,17018);
/*

!!eski versiyon!!

INSERT INTO onboarding.event_list
select drv2.cmusno
,case when drv2.event1='E-MAILVeryHigh' then 17013
		when drv2.event1='E-MAILHigh' then 17014
		when drv2.event1='SMSVeryHigh' then 17015
		when drv2.event1='SMSHigh' then 17016
		when drv2.event1='PUSHVeryHigh' then 17017
		when drv2.event1='PUSHHigh' then 17018
	end as event_id
,drv2.EVENT_DATE
,drv2.domain_type
,drv2.event1
,drv2.event2
,''
,drv2.channel 
from 
(SELECT cmusno as cmusno
		,DT as EVENT_DATE
		,'MARKETING_OFFER' AS DOMAIN_type
		,CASE	WHEN COM_COUNT BETWEEN 2 AND 5 THEN trim(UPPER(CHANNEL))||'High'
				WHEN COM_COUNT > 5 THEN trim(UPPER(CHANNEL))||'VeryHigh'	 
		END AS EVENT1
		,'' as EVENT2			
		,'' as EVENT3
		,UPPER(CHANNEL) as CHANNEL		
FROM
(
	SELECT
	CMUSNO
	,CHANNEL
	,gonderim_tar as DT
	,COUNT(*) as COM_COUNT
	FROM
	"goker"."pov_event_mark_offer_emailsms"
	JOIN
	onboarding.control_path control_tab 
	ON 1=1
	WHERE CHANNEL IS NOT NULL and gonderim_tar BETWEEN control_tab.start_date AND control_tab.end_date
	GROUP BY 1,2,3
) DRV
WHERE COM_COUNT>1 ) drv2;
*/
--STATEMENT 1: Insert Statement completed. 38282620 rows processed. 

/* 
112722,2017-02-21,MARKETING OFFER,SMS HIGH
112427,2017-09-13,MARKETING OFFER,SMS HIGH
112385,2016-09-23,MARKETING OFFER,E-MAIL VERY HIGH
112385,2016-09-26,MARKETING OFFER,E-MAIL VERY HIGH 
 */
 
 --Fes_kuyruk bos geldigi için eski versiyon üzerinden eventi olusturduk yeni versiyonu ise asagidaki kod.


--!!email ve sms yeni kod!!
drop table onboarding.marketing_tmp;
CREATE TABLE onboarding.marketing_tmp
DISTRIBUTE BY HASH(feskuyrukno)
COMPRESS
AS
SELECT k.*, t.tur, t.res_grp_code, o.product_name, o.product_category,
case when res_grp_code='FesMessageKampanya' and (upper (k.subject) like '%KAMPANYA%' or upper (k.subject) like '%TANITIM%'  or upper (k.prm) like '%TANITIM%'  or upper (k.prm) like '%KAMPANYA%' ) then 'Unica Kampanya'
    when res_grp_code='FesMessageKampanya' then 'Unica Bilgilendirme'
    when res_grp_code='FesMessageGenel' and (t.festanimno = 1198 or t.pazarlama_mes= 'E') then 'Genel Kampanya'
    else 'Genel Bilgilendirme' end Gonderim_detay_tur				
FROM
dw_out.fes_kuyruk_son k
JOIN
		onboarding.control_path control_tab 
		 ON 1=1 AND k.tarih BETWEEN control_tab.start_date AND control_tab.end_date
INNER JOIN
		staging.pov_fes_tanim t
		ON k.festanimno=t.festanimno
		AND k.drm='T'
LEFT JOIN
		onboarding.offer_table o
		on o.offer_code=k.offercode
    WHERE	(t.tur='E' 
			OR t.tur='S');
	
--select tur,festanimno,count(*) from onboarding.marketing_tmp group by 1,2;
			
					
CREATE TABLE onboarding.marketing_tmp_2
DISTRIBUTE BY HASH(feskuyrukno)
COMPRESS
AS
select distinct * 
from dw_out.fes_gonderim_hata h
inner JOIN onboarding.control_path control_tab 
	ON 1=1 AND tar BETWEEN control_tab.start_date AND control_tab.end_date;
		

INSERT INTO onboarding.event_list
select drv2.cmusno
--,case 	
----		when drv2.event1=
--		when drv2.event1='E-MAILVeryHigh' then 17004
--		when drv2.event1='E-MAILHigh' then 17005
----		when drv2.event1=
--		when drv2.event1='SMSVeryHigh' then 17006
--		when drv2.event1='SMSHigh' then 17007
----		when drv2.event1=
--		when drv2.event1='PUSHVeryHigh' then 17008
--		when drv2.event1='PUSHHigh' then 17009
--	end
,null as event_id
,drv2.EVENT_DATE
,drv2.domain_type
,drv2.event1
,drv2.event2
,drv2.event3
,drv2.channel 
from 
(SELECT cmusno as cmusno
		,DT as EVENT_DATE
		,'MARKETING_OFFER' AS DOMAIN_type
--		,CASE	WHEN COM_COUNT = 1 THEN trim(UPPER(CHANNEL))
--				WHEN COM_COUNT BETWEEN 2 AND 5 THEN trim(UPPER(CHANNEL))||'High'
--				ELSE trim(UPPER(CHANNEL))||'VeryHigh'
--				--WHEN COM_COUNT > 5 THEN trim(UPPER(CHANNEL))||'VeryHigh'	 
--		END 
		,case when Gonderim_detay_tur in ('Unica Bilgilendirme', 'Genel Bilgilendirme') then UPPER(CHANNEL)||'_Info'
			  when Gonderim_detay_tur = 'Unica Kampanya' then UPPER(CHANNEL)||'_CampSpc' 
			  when Gonderim_detay_tur = 'Genel Kampanya' then UPPER(CHANNEL)||'_CampGnr' 
			  else UPPER(CHANNEL)
		end AS EVENT1
		,CASE	WHEN product_name is not null then product_name
		 else '' end as EVENT2			
		,Gonderim_detay_tur as EVENT3
		,UPPER(CHANNEL) as CHANNEL		
FROM
(	SELECT
	CMUSNO
	,CHANNEL
	,gonderim_tar as DT
--	,COUNT(*) as COM_COUNT
	,product_name
	,product_category
	,Gonderim_detay_tur
	FROM
	(
	select 
		cmusno,
		case 
			when k.festanimno = 10030 then 'Push' 
			else (case	when tur='E' then 'E-Mail'
						when tur='S' and k.festanimno != 10030 then 'SMS' end) 
		end channel,
		k.tarih gonderim_tar, 
		product_name, 
		product_category,
		k.festanimno,
		Gonderim_detay_tur
--		k.ad
		from 
		onboarding.marketing_tmp k
		INNER JOIN 
		onboarding.marketing_tmp_2 h		
			ON k.feskuyrukno=h.feskuyrukno 				
		WHERE
			k.cmusno is not null
			and ((k.tur='S' and k.festanimno != 10030 and h.opr_akb='0')
					or (k.tur='E' and h.opr_akb='1')
					or k.festanimno = 10030)
		) a 
	/*	GROUP BY 1,2,3*/) drv0
	WHERE CHANNEL IS NOT NULL 
	) DRV2 ;

--select event1,event2,event3, count(*) from onboarding.event_list where  DOMAIN_type='MARKETING_OFFER' group by 1,2,3;
	
--DELETE FROM onboarding.event_list WHERE DOMAIN_type='MARKETING_OFFER' and event1 in ('PUSH','E-MAIL','SMS');	
	
-- Insert Statement completed. 333,817,931 (154,324,099) rows processed.

--count(1)
--220 389 758
--count(1)
--153 848 226


--SMS_RESPONSE	-1	Gecersiz Numara				fes_gonderim_hata opr_akb degeri
--SMS_RESPONSE	0	Basarili					fes_gonderim_hata opr_akb degeri sadece başarılı smsler alındı - goker
--SMS_RESPONSE	1	Iletilemedi					fes_gonderim_hata opr_akb degeri
--SMS_RESPONSE	2	Beklemede					fes_gonderim_hata opr_akb degeri
--SMS_RESPONSE	3	SMS Istemiyor				fes_gonderim_hata opr_akb degeri
--SMS_RESPONSE	4	Sistem Hatasi(iletilemedi)	fes_gonderim_hata opr_akb degeri

--EMAIL_RESPONSE	3	Silindi	fes_gonderim_hata opr_akb değeri
--EMAIL_RESPONSE	2	Başarısız	fes_gonderim_hata opr_akb değeri
--EMAIL_RESPONSE	1	Okundu	fes_gonderim_hata opr_akb değeri




/*Marketing Other Channel Events*/ 
INSERT INTO onboarding.event_list
SELECT cmusno 
, case when markt.event1='OFFER_NAPRESENT' then 17019
	when markt.event1='OFFER_ACCEPT' then 17020
	when markt.event1='OFFER_NOTPASS' then 17021
	when markt.event1='OFFER_REJECT' then 17022
	end as event_id
		,st_dttm as EVENT_DATE
		,'MARKETING_OFFER' AS DOMAIN_type
		,'OthChannel' as EVENT1
		,case when markt.event1='OFFER_NAPRESENT' then 'OfferNAPresent'
				when markt.event1='OFFER_ACCEPT' then 'OfferAccept'
				when markt.event1='OFFER_NOTPASS' then 'OfferNotPass'
				when markt.event1='OFFER_REJECT' then 'OfferReject'
		end as event2
		,product_name as EVENT3
		, trim(channel_name) 
FROM(
	SELECT  
	cst_no as cmusno,
	ofr_code as offer_code,
	obj_nm as offer_name,
	ofr_nm as object_name ,
	o.product_name,
	o.product_category,
	ofr_strt_dt,
	ofr_end_dt,
	main_cnl as offer_channel, 
	p.label as channel_name,
	st_code,
	st_dsc,
	crt_dt,
	rsp_dsc,
	st_dttm,
	case 
	when rsp_code ='100' then 'OFFER_ACCEPT'
	when rsp_code ='113' then 'OFFER_NAPRESENT'
	when rsp_code ='117' then 'OFFER_NAPRESENT'
	when rsp_code ='101' then 'OFFER_REJECT'	
	else 'OTHER'
	end as event1
	from 
	pov_mccrm_leads l
	JOIN
	onboarding.control_path control_tab 
	ON 1=1 and st_dttm BETWEEN control_tab.start_date AND control_tab.end_date
	LEFT JOIN
	pov_tbpamnomcle p
	ON cast(l.main_cnl as varchar(20))=p.code AND UPPER(p.language)='TR' AND p.type_nom_mib_obj_cod='CID'
	LEFT JOIN
	onboarding.offer_table o
	on l.ofr_code=o.offer_code 
	WHERE crn_f=1 --AND cast(crt_dt as date) > '2016-12-31'
	and st_dsc='TREATED'
	and rsp_code in ('101','113','100','117') )markt
WHERE st_dsc='TREATED' ;

--Insert Statement completed. 4495242 rows processed. 

--rsp_code,rsp_dsc
--100,Kabul/Tamamlandı
--100,Teklif Kabul Edildi/Randevu Alındı
--101,Red
--101,Teklif Reddedildi
--102,Randevu
--103,Ulaşılamadı
--112,Teklif İletilemedi
--113,Teklif Sunulmaya Uygun Değil
--113,Görüşülemedi
--114,Teklif İletilemedi-Görüşülemedi
--115,Teklif İletilemedi-İlgilenmedi
--116,Teklif İletilemedi-Güvenlikten Geçemedi
--117,Teklif Müşteriye Uygun Değil
--118,Anket Geri Bildirim

--STATEMENT 1: Insert Statement completed. 2504895 rows processed. 

--DELETE FROM onboarding.event_list WHERE DOMAIN_type='MARKETING_OFFER';

/* CASE	WHEN trim(channel_name)='CallPex (�a�r� Merkezi D�� Arama)' THEN 'CALLPEX OB'
				WHEN trim(channel_name)='�ube' THEN 'BRANCH'
				WHEN trim(channel_name)='�a�r� Merkezi' THEN 'TEB CC OB'
				WHEN trim(channel_name)='CMP (�a�r� Merkezi D�� Arama)' THEN 'CMP OB'
				WHEN trim(channel_name)='Gelen Musteri �letisim Firsatlari' THEN 'TEB CC/BRANCH IB'
		END as  CHANNEL

*/


/*
select event_id, domain_type, EVENT1, EVENT2, EVENT3, count(cmusno)
from onboarding.event_list
where domain_type='MARKETING_OFFER' 
group by event_id, domain_type, EVENT1, EVENT2, EVENT3;

*/



--select * from goker.event_list where DOMAIN_type='MARKETING_OFFER' and event1='SMSHigh'