
--delete from onboarding.event_list where domain_type='DEPOSIT';

--STATEMENT 1: Delete Statement completed. 2229748 rows processed. 

--select b.tar as ac_tar_time 
--from ybs_hesap_ortak_musteri  a, tb.vy_hesap b 
--where a.sube = b.sube 
--and a.hesno = b.hesno ;

--Deposit Opening Event O/N hesaplari ekleyip event2 de ayristirdim-melis
-- TL, FX all time deposit accounts

--select event1, event2, count(*) from onboarding.event_list where domain_type='DEPOSIT' group by 1,2;


INSERT INTO onboarding.event_list
SELECT cmusno 
		, case when bankaurunid in ('1041','1105','7045','7044','6431','6432','6866','6867') then 13002
			else 13001
		end as event_id
		, ac_tar as EVENT_DATE
		,'DEPOSIT'
		,'DepositOpening' as EVENT1
		,case when bankaurunid in ('1041','1105','7045','7044','6431','6432','6866','6867') then 'O/N' 
		else 'TimeDeposit' end as EVENT2
		,'' as EVENT3
		,'' as chn_name		
FROM
(SELECT 
	m.cmusno,
	m.sube, 
	m.hesno,
	h.tar as ac_tar, 
	h.kap_tar,
	m.bankaurunid
	FROM staging.pov_ybs_hesap_ortak_musteri m
	JOIN dw_out.hesap h
		on m.sube = h.sube 
		and m.hesno = h.hesno 
	JOIN
	onboarding.control_path control_tab
	ON 1=1
	WHERE m.musno = m.esas_musno
	AND bankaurunid IN (  select distinct level0
							from staging.pov_dw_banka_urun_agac_hyr 
							where ref_banka_urun_tip='1'  
							and path LIKE '/1740%'
							and (urun_id2 in ('1807','1827','6431','6432','6866','6867') or urun_id3 in ('1804','1832','7044') or urun_id4 in ('1041','1105','7045'))
							)
	and h.tar between control_tab.start_date and control_tab.end_date ) DRV ;
	
--Executed as Multiple statements.  
--STATEMENT 1: Insert Statement completed. 944687   rows processed



-- Demand Deposit Opening // daha onceden olusturulan event islem tablosundan aliyordu Artik Ybsden aliyor
--TL , FX all demand deposit accounts
INSERT INTO onboarding.event_list
SELECT cmusno 
		,13003 as event_id
		, ac_tar as EVENT_DATE
		,'DEPOSIT'
		,'DepositOpening' as EVENT1
		,'DemandDeposit' as EVENT2
		,'' as EVENT3
		,'' as CHN_NAME	
from
(SELECT 
	m.cmusno,
	m.sube, 
	m.hesno,
	h.tar as ac_tar, 
	h.kap_tar,
	m.bankaurunid
	FROM staging.pov_ybs_hesap_ortak_musteri m
	JOIN dw_out.hesap h
		on m.sube = h.sube 
		and m.hesno = h.hesno 
	JOIN
	onboarding.control_path control_tab
	ON 1=1
	WHERE m.musno = m.esas_musno
	AND bankaurunid IN (    select distinct level0
							from staging.pov_dw_banka_urun_agac_hyr 
							where ref_banka_urun_tip='1'  
							and path LIKE '/1740%'
							and (urun_id2 in ('1818','1828') or urun_id3 in ('1138','1140','1823','1824'))
							)
	and h.tar between control_tab.start_date and control_tab.end_date) DRV ;
--STATEMENT 2: Insert Statement completed. 1787023  rows processed.

/*
select event_id, domain_type, EVENT1, EVENT2, EVENT3, count(cmusno)
from onboarding.event_list
where domain_type='DEPOSIT' 
group by event_id, domain_type, EVENT1, EVENT2, EVENT3;

select  domain_type, EVENT1, EVENT2, EVENT3, count(cust_id)
from staging.path_events
where domain_type='DEPOSIT'
group by  domain_type, EVENT1, EVENT2, EVENT3;
*/
	
	



	
--Deposit Closing Event
-- TL, FX all time deposit accounts
INSERT INTO onboarding.event_list
SELECT cmusno 
		,case when bankaurunid in ('1041','1105','7045','7044','6431','6432','6866','6867') then 13005 
			else 13004
		end as event_id
		, kap_tar as EVENT_DATE
		,'DEPOSIT'
		,'DepositClosing' as EVENT1
		,case when bankaurunid in ('1041','1105','7045','7044','6431','6432','6866','6867') then 'O/N' 
		else 'TimeDeposit' end as EVENT2
		,'' as EVENT3
		,'' as chn_name		
FROM
(
	SELECT 
	m.cmusno,
	m.sube, 
	m.hesno,
	h.tar as ac_tar, 
	h.kap_tar,
	m.bankaurunid
	FROM staging.pov_ybs_hesap_ortak_musteri m 
	JOIN dw_out.hesap h
		on m.sube = h.sube 
		and m.hesno = h.hesno 
	JOIN
	onboarding.control_path control_tab
	ON 1=1	
	WHERE m.musno = m.esas_musno
	AND bankaurunid IN (  select distinct level0
							from staging.pov_dw_banka_urun_agac_hyr 
							where ref_banka_urun_tip='1'  
							and path LIKE '/1740%'
							and (urun_id2 in ('1807','1827','6431','6432','6866','6867') or urun_id3 in ('1804','1832','7044') or urun_id4 in ('1041','1105','7045'))
							)
	and h.kap_tar between control_tab.start_date and control_tab.end_date
)DRV;
--STATEMENT 3: Insert Statement completed. 646928  rows processed.


-- Demand Deposit Closing // daha onceden olusturulan event islem tablosundan aliyordu Artik Ybsden aliyor
	
INSERT INTO onboarding.event_list
SELECT cmusno 
		, 13006 as event_id
		, kap_tar as EVENT_DATE
		,'DEPOSIT'
		,'DepositClosing' as EVENT1
		,'DemandDeposit' as EVENT2
		,'' as EVENT3
		,'' as chn_name	
from
(SELECT 
	m.cmusno,
	m.sube, 
	m.hesno,
	h.tar as ac_tar, 
	h.kap_tar,
	m.bankaurunid
	FROM staging.pov_ybs_hesap_ortak_musteri m
	JOIN dw_out.hesap h
		on m.sube = h.sube 
		and m.hesno = h.hesno 	
	JOIN
	onboarding.control_path control_tab
	ON 1=1
	WHERE m.musno = m.esas_musno
	AND bankaurunid IN (    select distinct level0
							from staging.pov_dw_banka_urun_agac_hyr 
							where ref_banka_urun_tip='1'  
							and path LIKE '/1740%'
							and (urun_id2 in ('1818','1828') or urun_id3 in ('1138','1140','1823','1824'))
							)
	and h.kap_tar between control_tab.start_date and control_tab.end_date) DRV ;
--STATEMENT 4: Insert Statement completed. 919217  rows processed.

	




INSERT INTO onboarding.event_list
SELECT cmusno 
		,CASE WHEN Days_Close_Early BETWEEN 0 AND 7	THEN 13007 
			WHEN Days_Close_Early BETWEEN 8 AND 15	THEN 13008
			WHEN Days_Close_Early BETWEEN 16 AND 30	THEN 13009
			WHEN Days_Close_Early > 30	THEN 13010
			WHEN Days_Close_Early > 90	THEN 13011
		end as event_id
		, kap_tar as EVENT_DATE
		,'DEPOSIT'
		,'DepositEarlyClose' as EVENT1
		,CASE 	WHEN Days_Close_Early > 90	THEN '3MonthEarly'
				WHEN Days_Close_Early > 30	THEN '1MonthEarly'
				WHEN Days_Close_Early BETWEEN 16 AND 30	THEN '3WeekEarly'
				WHEN Days_Close_Early BETWEEN 8 AND 15	THEN '2WeekEarly'
				WHEN Days_Close_Early BETWEEN 0 AND 7	THEN '1WeekEarly'
		END
		as EVENT2
		,'' as EVENT3
		,'' as CHN_NAME		
FROM
(
	SELECT 
	tarih,
	m.cmusno,
	m.sube, 
	m.hesno,
	t.tar as ac_tar, 
	t.kap_tar,
	h.vade_bas_tar,
	h.vade_son_tar,
	m.bankaurunid,
	CAST(h.vade_son_tar as DATE)-CAST(t.kap_tar as DATE) as Days_Close_Early
	FROM staging.pov_ybs_hesap_ortak_musteri m
	JOIN dw_out.hesap t
		on m.sube = t.sube 
		and m.hesno = t.hesno 	
	JOIN
	onboarding.control_path control_tab
		ON 1=1
	JOIN staging.pov_ybs_hes_vade h
		on m.hesno=h.hesno
		and m.sube=h.sube 
	where m.musno = m.esas_musno	
	AND bankaurunid IN (  select distinct level0
							from staging.pov_dw_banka_urun_agac_hyr 
							where ref_banka_urun_tip='1'  
							and path LIKE '/1740%'
							and (urun_id2 in ('1807','1827') or urun_id3 in ('1804','1832'))
							and level0 not in ('7045','1105','1041')
					 	)
	and t.kap_tar between control_tab.start_date and control_tab.end_date
	and tarih='2017-05-31'
	and t.kap_tar<>h.vade_bas_tar
	and t.kap_tar<h.vade_son_tar
) DRV;
--STATEMENT 5: Insert Statement completed. 46618  rows processed.