/*
 * ---------------------------------- CALLCENTER DOMAIN EVENTS -----------------------------------
 * irtibat noya göre gruplandığında birden fazla kayıt gelenler için ürün numarası null olanlar alınmamıştır.
 * aynı şekilde gruplandığında tek kayıt gelen ve ürün numarası null olan kayıtlar tutulmuştur.
 */

drop table if exists onboarding.callcenter_tmp1;
create table onboarding.callcenter_tmp1
distribute by hash(irtibatno)
compress
as
select 
	x.irt_bas_tar, 
	x.cmusno, 
	x.irtibatno, 
	x.irt_yon, 
	x.ref_cagri_tur, 
	x.urunno,x.urunturno, 
	u.ad 
from
	(
	select 
		a.irt_bas_tar, 
		a.cmusno, 
		a.irtibatno, 
		a.irt_yon, 
		a.ref_cagri_tur, 
		d.urunno,
		d.urunturno 
	from
		(
		select 
			I.irt_bas_tar,
			I.cmusno, 
			I.irtibatno, 
			I.irt_yon, 
			I.ref_cagri_tur 
		from staging.pov_irtibat I 
		inner join onboarding.control_path control_tab
		ON 1=1
		left join 
			(
			select 
				kykontakno, 
				tar, 
				cmusno, 
				ref_geri_arama_tur, 
				irtibatno, 
				cle_leadid 
			from dw_out.ky_kontak 
			where 
			cle_leadid is not null and tar::date >= '01-01-2015' 
			) K
		ON k.irtibatno=I.irtibatno
		where 
		K.kykontakno is null  
		and kanalno in (5900, 8201, 8220) 
		and irt_yon in ('I','R','O')
		and irt_bas_tar BETWEEN CAST(control_tab.start_date as DATE) 
							AND CAST(control_tab.end_date as DATE)
		) a
	inner join staging.pov_irt_isl D
	on a.irtibatno =D.irtibatno
	group by 1,2,3,4,5,6,7
	) x
left join dw_out.urun_tur u
on u.urunturno=x.urunturno
;

drop table if exists onboarding.callcenter_tmp2;
create table onboarding.callcenter_tmp2
distribute by hash(irtibatno)
compress
as
select 
	irtibatno, 
	count(*) as cnt 
from onboarding.callcenter_tmp1
group by 1;


insert into onboarding.event_list
select 
		cmusno
		,case
			when event1 = 'Inbnd_Br' and event2 = 'Autopymnt' then 35001
			when event1 = 'Inbnd_CC' and event2 = 'Autopymnt' then 35002
			when event1 = 'Outbnd_BR' and event2 = 'Autopymnt' then 35003
			when event1 = 'Outbnd_CC' and event2 = 'Autopymnt' then 35004
			when event1 = 'Inbnd_Br' and event2 = 'Ccard' then 35005
			when event1 = 'Inbnd_CC' and event2 = 'Ccard' then 35006
			when event1 = 'Outbnd_BR' and event2 = 'Ccard' then 35007
			when event1 = 'Outbnd_CC' and event2 = 'Ccard' then 35008
			when event1 = 'Inbnd_Br' and event2 = 'VirCcard' then 35009
			when event1 = 'Inbnd_CC' and event2 = 'VirCcard' then 35010
			when event1 = 'Outbnd_BR' and event2 = 'VirCcard' then 35011
			when event1 = 'Outbnd_CC' and event2 = 'VirCcard' then 35012
			when event1 = 'Inbnd_Br' and event2 = 'DpstDmnd' then 35013
			when event1 = 'Inbnd_CC' and event2 = 'DpstDmnd' then 35014
			when event1 = 'Outbnd_BR' and event2 = 'DpstDmnd' then 35015
			when event1 = 'Outbnd_CC' and event2 = 'DpstDmnd' then 35016
			when event1 = 'Inbnd_Br' and event2 = 'DpstO/N' then 35017
			when event1 = 'Inbnd_CC' and event2 = 'DpstO/N' then 35018
			when event1 = 'Outbnd_BR' and event2 = 'DpstO/N' then 35019
			when event1 = 'Outbnd_CC' and event2 = 'DpstO/N' then 35020
			when event1 = 'Inbnd_Br' and event2 = 'DpstTime' then 35021
			when event1 = 'Inbnd_CC' and event2 = 'DpstTime' then 35022
			when event1 = 'Outbnd_BR' and event2 = 'DpstTime' then 35023
			when event1 = 'Outbnd_CC' and event2 = 'DpstTime' then 35024
			when event1 = 'Inbnd_Br' and event2 = 'Dcard' then 35025
			when event1 = 'Inbnd_CC' and event2 = 'Dcard' then 35026
			when event1 = 'Outbnd_BR' and event2 = 'Dcard' then 35027
			when event1 = 'Outbnd_CC' and event2 = 'Dcard' then 35028
			when event1 = 'Inbnd_Br' and event2 = 'Insrance' then 35029
			when event1 = 'Inbnd_CC' and event2 = 'Insrance' then 35030
			when event1 = 'Outbnd_BR' and event2 = 'Insrance' then 35031
			when event1 = 'Outbnd_CC' and event2 = 'Insrance' then 35032
			when event1 = 'Inbnd_Br' and event2 = 'Invsmnt' then 35033
			when event1 = 'Inbnd_CC' and event2 = 'Invsmnt' then 35034
			when event1 = 'Outbnd_BR' and event2 = 'Invsmnt' then 35035
			when event1 = 'Outbnd_CC' and event2 = 'Invsmnt' then 35036
			when event1 = 'Inbnd_Br' and event2 = 'PerLn' then 35037
			when event1 = 'Inbnd_CC' and event2 = 'PerLn' then 35038
			when event1 = 'Outbnd_BR' and event2 = 'PerLn' then 35039
			when event1 = 'Outbnd_CC' and event2 = 'PerLn' then 35040
			when event1 = 'Inbnd_Br' and event2 = 'Mrtgage' then 35041
			when event1 = 'Inbnd_CC' and event2 = 'Mrtgage' then 35042
			when event1 = 'Outbnd_BR' and event2 = 'Mrtgage' then 35043
			when event1 = 'Outbnd_CC' and event2 = 'Mrtgage' then 35044
			when event1 = 'Inbnd_Br' and event2 = 'CarLn' then 35045
			when event1 = 'Inbnd_CC' and event2 = 'CarLn' then 35046
			when event1 = 'Outbnd_BR' and event2 = 'CarLn' then 35047
			when event1 = 'Outbnd_CC' and event2 = 'CarLn' then 35048
			when event1 = 'Inbnd_Br' and event2 = 'OnlnBnking' then 35049
			when event1 = 'Inbnd_CC' and event2 = 'OnlnBnking' then 35050
			when event1 = 'Outbnd_BR' and event2 = 'OnlnBnking' then 35051
			when event1 = 'Outbnd_CC' and event2 = 'OnlnBnking' then 35052
		end as event_id
		,EVENT_DATE
		,domain_type
		,event1
		,event2
		,event3
		,chn_name
from 
(select 
		cmusno
		,irt_bas_tar  as EVENT_DATE
		,'CALL_CENTER' as domain_type
		,case 
			when irt_yon in ('I','R') and ref_cagri_tur ='SUB' then 'inbound_sube'
			when irt_yon in ('I','R') and (ref_cagri_tur <> 'SUB' or  ref_cagri_tur  is null)  then 'inbound_cc'
			when irt_yon ='O' and ref_cagri_tur ='SUB' then 'outbound_sube'
			when irt_yon ='O' and (ref_cagri_tur <> 'SUB' or  ref_cagri_tur  is null)  then 'outbound_cc' 
		end as EVENT1
		,case 
			when group1='auto_payment' then 'auto_payment'
			when group1='credit_card' and group2 is null then 'credit_card'
			when group1='credit_card' and group2='virtual' then 'virtual_credit_card'
			when group1='deposit' and group2='demand' then 'demand_deposit'
			when group1='deposit' and group2='o/n' then 'o/n_deposit'
			when group1='deposit' and group2='time' then 'time_deposit'
			when group1='debit_card' then 'debit_card'
			when group1='insurance' then 'insurance'
			when group1='invesment' then 'invesment'
			when group1='loan' and group2='personal' then 'personal_loan'
			when group1='loan' and group2='mortgage' then 'mortgage_loan'
			when group1='loan' and group2='car' then 'car_loan'
			when group1='online_banking' then 'online_banking'
		else '' end as EVENT2
		,'' as EVENT3
		,'CC' as chn_name	
from 
	(select 	a.*, 
		b.cnt,
		c.group1,	
		c.group2
	from onboarding.callcenter_tmp1 a
	inner join onboarding.callcenter_tmp2 b 
	on a.irtibatno=b.irtibatno
	left join onboarding.urunturno_aciklamalar c
	on a.ad=c.ad
	where 
	((b.cnt>1 and (urunturno is not null) and
		group1 in  ('auto_payment',
					'credit_card',
					'deposit',
					'debit_card',
					'insurance',
					'invesment',
					'loan',
					'online_banking'))
	or b.cnt=1)
	and cmusno != 99999999
) a ) drv;
	
--Insert Statement completed. 26.439.995  rows processed. 
--DELETE FROM onboarding.event_list WHERE DOMAIN_type='CALL_CENTER';

drop table onboarding.callcenter_tmp1;
drop table onboarding.callcenter_tmp2;

--
--select count(distinct cmusno)
--from onboarding.event_list
--where domain_type='CALL_CENTER';
--
--select *
--from onboarding.event_list
--where domain_type='CALL_CENTER'
--and cmusno=99999999;
--
--select *
--from onboarding.event_list
--where domain_type='CALL_CENTER'
--and cmusno=99999999;

--count( distinct cmusno)
--3 297 001

--count(cmusno)
--53 282 328

/*


select max(cnt)
from (
select cmusno, count(distinct event_date, event1,event2) cnt
from onboarding.event_list
where domain_type='CALL_CENTER'
group by 1 ) drv
--where cnt>100;

select *
from onboarding.callcenter_tmp1
where cmusno=99999999;

select * 
from staging.pov_irtibat
where irtibatno=20180430164512471941

select * 
from staging.pov_dwd_kon_musteri
where cmusno=99999999

select urunturno,count(distinct irtibatno) from onboarding.callcenter_tmp1 where cmusno=3776751 group by 1

select group1,count(distinct irtibatno), count(*) 
from (
select 	a.*, 
		b.cnt,
		c.group1,	
		c.group2
	from onboarding.callcenter_tmp1 a
	inner join onboarding.callcenter_tmp2 b 
	on a.irtibatno=b.irtibatno
	left join onboarding.urunturno_aciklamalar c
	on a.ad=c.ad
	where 
	((b.cnt>1 and (urunturno is not null) and
		group1 in  ('auto_payment',
					'credit_card',
					'deposit',
					'debit_card',
					'insurance',
					'invesment',
					'loan',
					'online_banking'))
	or b.cnt=1)
	and cmusno != 99999999
) a
--where group1='deposit'
group by 1
--order by cnt desc;


select event1, event2, count(*)
from onboarding.event_list
where domain_type='CALL_CENTER'
group by 1,2;

select distinct group1 from (
select * from dw_out.urun_tur a
inner join onboarding.urunturno_aciklamalar c
on a.ad=c.ad ) g